# std::destroy_n

From cppreference.com
< cpp‎ | memory

Defined in header `<memory>` |  |
template< class ForwardIt, class Size > ForwardIt destroy_n( ForwardIt first, Size n ); | (1) | (since C++17)
template< class ExecutionPolicy, class ForwardIt, class Size > ForwardIt destroy_n( ExecutionPolicy&& policy, ForwardIt first, Size n ); | (2) | (since C++17)

1) Destroys the `n` objects in the range starting at `first`, as if by

    for (; n > 0; (void) ++first, --n)
      std::destroy_at(std::addressof(*first));

2) Same as (1), but executed according to `policy`. This overload does not participate in overload resolution unless std::is_execution_policy_v<std::decay_t<ExecutionPolicy>> is true

### Parameters

first | - | the beginning of the range of elements to destroy
n | - | the number of elements to destroy
policy | - | the execution policy to use. See execution policy for details.
Type requirements
- `ForwardIt` must meet the requirements of `ForwardIterator`.
- No increment, assignment, comparison, or indirection through valid instances of `ForwardIt` may throw exceptions.

### Return value

The end of the range of objects that has been destroyed (i.e., std::next(first, n)).

### Complexity

Linear in `n`.

### Exceptions

The overload with a template parameter named `ExecutionPolicy` reports errors as follows:

- If execution of a function invoked as part of the algorithm throws an exception and `ExecutionPolicy` is one of the three standard policies, std::terminate is called. For any other `ExecutionPolicy`, the behavior is implementation-defined.
- If the algorithm fails to allocate memory, std::bad_alloc is thrown.

### Possible implementation

    template<class ForwardIt, class Size>
    ForwardIt destroy_n( ForwardIt first, Size n )
    {
      for (; n > 0; (void) ++first, --n)
        std::destroy_at(std::addressof(*first));
      return first;
    }

### Example

| This section is incomplete Reason: no example

### See also

destroy (C++17) | destroys a range of objects (function template)
destroy_at (C++17) | destroys an object at a given address (function template)

Retrieved from "http://en.cppreference.com/mwiki/index.php?title=cpp/memory/destroy_n&oldid=86818"
Category:

- Todo no example